var YaAbout = {
  nsIYa: Cc["@yandex.ru/yasearch;1"].getService(Ci.nsIYaSearch).wrappedJSObject,
  
  onDialogLoad: function() {
    this.fillAppInfo();
  },
  
  fillAppInfo: function() {
    const nsIYa = this.nsIYa;
    
    let extensionVersion = nsIYa.barExtensionMajorVersion;
    
    let barVersionSpan = document.getElementById("bar-version").lastChild;
    barVersionSpan.textContent = extensionVersion;
    barVersionSpan.setAttribute("tooltiptext", extensionVersion + "." + nsIYa.versionBuild);
    
    let versionStr = nsIYa.version;
    
    let copyrightYearSpan = document.getElementById("copyright-year");
    let copyrightYearValue = parseInt(versionStr.substr(0,4), 10);
    
    if (parseInt(copyrightYearSpan.textContent, 10) < copyrightYearValue)
      copyrightYearSpan.textContent = copyrightYearValue;
    
    versionStr = [versionStr.substr(6,2), versionStr.substr(4,2), versionStr.substr(0,4)].join(".");
    
    document.getElementById("bar-date").lastChild.textContent = versionStr;
  },
  
  openBarSite: function(aLinkElement) {
    var href = aLinkElement.getAttribute("href");
    this.nsIYa.loadURI(href, "tab", {action:3010});
    
    setTimeout(function() {
      document.documentElement.cancelDialog();
    }, 2);
    
    return false;
  }
}