<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "chrome://yasearch/locale/bookmarks/bookmarks.dtd">

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:template match="yaru[@yasearch_error]">
  <html:div class="yaru-error">
    <html:p>&yasearch.livewindow.lastfriends.error.1.label;.</html:p>
    <html:p>&yasearch.livewindow.lastfriends.error.2.label; <html:a href="mailto:support@bar.yandex.ru?subject=&yasearch.livewindow.lastfriends.error.support.subject;">&yasearch.livewindow.lastfriends.error.support.label;</html:a>.</html:p>
  </html:div>
</xsl:template>

<xsl:template match="yaru">
  <html:div>
    <xsl:choose>
      <xsl:when test="count(friends/friend) = 0">
        <html:p>&yasearch.livewindow.lastfriends.nolinks.1.label;.</html:p>
        <html:p>&yasearch.livewindow.lastfriends.nolinks.2.label;.</html:p>
        <html:p>&yasearch.livewindow.lastfriends.nolinks.3.label; <html:a href="http://{@yasearch_login}.ya.ru/posts_add_friend.xml" yaLinkAction="1955">&yasearch.livewindow.lastfriends.nolinks.4.label;</html:a>.</html:p>
      </xsl:when>
      <xsl:otherwise>
        <vbox flex="1" id="yasearch-livewindow-firends-links">
          <grid>
            <columns>
              <column style="max-width:10em"/>
              <column flex="1"/>
            </columns>
            <rows>
              <xsl:apply-templates select="friends/friend"/>
            </rows>
          </grid>
        </vbox>
      </xsl:otherwise>
    </xsl:choose>
  </html:div>
</xsl:template>

<xsl:template match="friends/friend">
  <row>
    <hbox class="friend-login" tooltip="yasearch-bookmark-links-tooltip"
          yaTooltiptext="{name}" yaLinkAction="1935" yaLinkTarget="new-tab">
      <label value="{substring(normalize-space(name), 1, 1)}" href="http://{login}.ya.ru"/>
      <label value="{substring(normalize-space(name), 2, 200)}" href="http://{login}.ya.ru"/>
      <label value=":"/>
    </hbox>
    <hbox flex="1" class="friend-url" tooltip="yasearch-bookmark-links-tooltip"
          yaLinkAction="1940">
      <xsl:choose>
        <xsl:when test="string-length(normalize-space(title)) = 0">
          <xsl:attribute name="yaTooltiptext">
            <xsl:value-of select="url"/>
          </xsl:attribute>
          <label value="{substring(normalize-space(url), 1, 400)}" href="{url}"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="yaTooltiptext">
            <xsl:value-of select="title"/>
          </xsl:attribute>
          <label value="{substring(normalize-space(title), 1, 400)}" href="{url}"/>
        </xsl:otherwise>
      </xsl:choose>
    </hbox>
  </row>
</xsl:template>

</xsl:stylesheet>