(function() {

var APP_NAME = "yasearch";

function OverlayControllerF() {
    this._appName = APP_NAME;
    
    this._coreCompContract = "@yandex.ru/custombarcore;" + this._appName;
    this._barCore = Components.classes[this._coreCompContract].getService().wrappedJSObject;
    
    this._id = this._barCore.application.getNewControllerID(this);
    
    this._logger = this._barCore.Log4Moz.repository.getLogger(this._appName + ".OverlayController");
    this._logger.level = this._barCore.Log4Moz.Level.Debug;
    this._logger.config("Adding window load event listener");
    
    window.addEventListener("load", this, false);
    
    this._init();
}

OverlayControllerF.prototype = {
    get id() {
        return this._id;
    },
    
    get window() {
        return window;
    },
    
    get guiBuilder() {
        return this._guiBuilder;
    },
    
    get windowEngine() {
        return this._wndEngine;
    },
    
    handleEvent: function(event) {
        switch (event.type) {
            case "load":
                this._onOverlayLoaded(event);
                break;
            case "unload":
                this._onOverlayUnload(event);
                break;
        }
    },
    
    _id: 0,
    _appName: null,
    _coreCompContract: null,
    _barCore: null,
    _logger: null,
    _wndEngine: null,
    _guiBuilder: null,
    
    _init: function() {
        this._wndEngine = new this._barCore.Lib.XB.WindowEngine(this._barCore.application.widgetsRegistry, this);
        this._guiBuilder = new this._barCore.Lib.XB.XULBuilder(this._wndEngine, this);
    },
    
    _onOverlayLoaded: function(loadEvent) {
        this._logger.info("Overlay loaded");
        
        loadEvent.currentTarget.removeEventListener("load", this, false);
        loadEvent.currentTarget.addEventListener("unload", this, false);
    },
    
    _onOverlayUnload: function(unloadEvent) {
        this._logger.info("Overlay unloads");
        try {
            unloadEvent.currentTarget.removeEventListener("unload", this, false);
            
            this._guiBuilder.finalize();
            this._wndEngine.clear();
        }
        finally {
            this._barCore.application.forgetController(this.id);
        }
        
        this._guiBuilder = null;
        this._wndEngine = null;
        
        this._logger = null;
        this._barCore = null;
    }

};

window[APP_NAME + "OverlayController"] = new OverlayControllerF();
})();