var YaWelcome = {
  onpenerYa: window.opener.Ya,
  
  nsIYa: Cc["@yandex.ru/yasearch;1"].getService(Ci.nsIYaSearch).wrappedJSObject,
  
  get observerService() {
    return Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
  },
  
  get dialogContentHeight() {
    let dialogContent = document.getElementById("dialogcontent");
    
    let contentHeight = 0,
        contentStyle = window.getComputedStyle(dialogContent, null);
    
    ["border-top-width", "border-bottom-width", "margin-top", "margin-bottom"]
    .forEach(function(aPropName) {
      contentHeight += parseInt(contentStyle.getPropertyValue(aPropName), 10);
    });
    
    contentHeight += dialogContent.selectedPanel.currentHeight;
    
    return contentHeight;
  },
  
  sizeToContent: function(aCenterWindow) {
    if (window.outerHeight < 100 && !aCenterWindow)
      return;
    
    let centerWindow = !!(aCenterWindow || window.outerHeight < 100);
    
    setTimeout(function() {
      if (!centerWindow) {
        window.sizeToContent();
        return;
      }
      
      if (window.outerHeight < 100)
        window.outerHeight = 100;
      
      YaWelcome.toggleCollapsedView(YaWelcome.getAboutServiceCollapsedState());
      
      //let docElement = document.documentElement;
      //docElement.style.height = YaWelcome.dialogContentHeight + 10 + "px";
      window.sizeToContent();
      
      window.centerWindowOnScreen();
      
      // todo: fx 3.6a2 mac os: broken centerWindowOnScreen
      // wrong screen.availLeft, screen.availWidth, etc.
      if (window.screenX == 50000 && window.screenY == 50000) {
        let appInfo = YaWelcome.nsIYa.AppInfo;
        if (appInfo.OS.isMacOS && appInfo.browser.isGreaterThenFx35) {
          try {
            let primaryScreen = Cc["@mozilla.org/gfx/screenmanager;1"]
                                    .getService(Ci.nsIScreenManager)
                                    .primaryScreen;
            
            let left = {}, top = {}, width = {}, height = {};
            primaryScreen.GetAvailRect(left, top, width, height);
            
            window.moveTo((left.value + width.value - window.outerWidth)/2,
                          (top.value + height.value - window.outerHeight)/2);
          } catch(e) {}
        }
      }
      
      new YaDragWindow([document.getElementById("tabbox-welcome"),
                        document.getElementById("tabbox-services")]);
    
    }, centerWindow ? 300 : 100);
  },
  
  get LOGIN_STATES() {
    return this.nsIYa.LOGIN_STATES;
  },
  
  get loginState() {
    return this.nsIYa.loginState;
  },
  
  cancelDialog: function() {
    return document.documentElement.cancelDialog();
  },
  
  aboutService: "bar",
  callbackElementId: "",
  
  get dialogContent() {
    return document.getElementsByTagNameNS("http://bar.yandex.ru/firefox", "dialogcontent").item(0);
  },
  
  getAboutServiceCollapsedState: function() {
    if (!this.aboutService)
      return false;
    
    const prefName = "yasearch.general.ui.mybar.collapsed.services";
    var prefValue = this.nsIYa.getCharPref(prefName) || "";
    
    return !!(prefValue.indexOf("|" + this.aboutService + "|") > -1);
  },
  
  setAboutServiceCollapsedState: function(aState) {
    if (!this.aboutService)
      return;
    
    const prefName = "yasearch.general.ui.mybar.collapsed.services";
    var prefValue = this.nsIYa.getCharPref(prefName) || "";
    
    var serviceFlag = "|" + this.aboutService + "|";
    
    prefValue = prefValue.replace(serviceFlag, "");
    
    if (aState)
      prefValue += serviceFlag;
    
    this.nsIYa.setCharPref(prefName, prefValue);
  },
  
  onDialogLoad: function() {
    // can't use opacity
    window.outerWidth = 3;
    window.outerHeight = 3;
    
    window.moveTo(50000,50000);
    
    let AppInfo = this.nsIYa.AppInfo;
    if (AppInfo.OS.isWindows && AppInfo.browser.isGreaterThenFx30) {
      // make shadow
      let shadowAttribute = document.createAttribute("yashadow");
      shadowAttribute.value = "window";
      document.documentElement.attributes.setNamedItem(shadowAttribute);
    } else if (AppInfo.OS.isLinux) {
      // linux bugs; remove transparent background
      document.documentElement.attributes.removeNamedItem("yatransparent");
    }
    
    new YaUtils.KeyCorrector(document.getElementById("yasearch-username"));
    new YaUtils.KeyCorrector(document.getElementById("yasearch-password"));
    
    if ("arguments" in window && window.arguments.length && window.arguments[0]) {
      this.aboutService = window.arguments[0];
      this.callbackElementId = window.arguments[1] || "";
    }
    
    if (this.aboutService == "bookmarks")
      this.aboutService = "zakladki";
    
    var serviceXSLTParams = { serviceType: this.aboutService };
    var serviceData = this.nsIYa.Counters.getServiceLocalizedXML(this.aboutService);
    if (serviceData) {
      var serviceDataURL = serviceData.url;
      if (serviceDataURL)
        serviceXSLTParams.serviceURL  = serviceDataURL.toString();
      
      if ("@action" in serviceDataURL) {
        var serviceDataAction = parseInt(serviceDataURL.@action, 10);
        if (serviceDataAction)
          serviceXSLTParams.serviceURLAction = serviceDataAction + 1;
      }
    }
    
    var filePath = "services/mybar/services.about.";
    var aboutService = this.nsIYa.getDOMDocContent2(filePath + "xsl", filePath + "xml", serviceXSLTParams);
    
    if (aboutService) {
      document.getElementById("tabbox-welcome").setAttribute("title", aboutService.getAttribute("serviceTitle"));
      document.getElementById("about-service-holder").appendChild(aboutService);
    }
    
    document.getElementById("yasearch-username").popup.addEventListener("mouseup", this, true);
    document.getElementById("yasearch-username").popup.addEventListener("mousemove", this, true);
    
    this.handleLoginStateChanged();
    
    this.sizeToContent(true);
    
    this.observerService.addObserver(this, "Ya-Login-State-Changed", false);
    this.observerService.addObserver(this, "Ya-Refresh-Data", false);
  },
  
  onDialogUnload: function() {
    this.observerService.removeObserver(this, "Ya-Refresh-Data");
    this.observerService.removeObserver(this, "Ya-Login-State-Changed");
    
    document.getElementById("yasearch-username").popup.removeEventListener("mouseup", this, true);
    document.getElementById("yasearch-username").popup.removeEventListener("mousemove", this, true);
  },
  
  onDialogAccept: function() {
    if (document.getElementById("yasearch-username").yaValueIsNotValid(true) ||
        document.getElementById("yasearch-password").yaValueIsNotValid(true)) {
      return false;
    }
    
    var cookiesHostName = "yandex.ru";
    var cookiesAllowed = this.nsIYa.isCookiesAllowedForHost(cookiesHostName);
    
    if (!cookiesAllowed) {// null (when permissionManager.DENY_ACTION) || false
      var cookieBehaviorValue = cookiesAllowed === null ? -1 : this.nsIYa.getIntPref("network.cookie.cookieBehavior");
        
      var dialogTextAppend = "";
      
      switch (cookieBehaviorValue) {
        case 1:
          dialogTextAppend = " " + this.getLocalizedString("Cookies3PartyDisabledText");
          break;
        
        case 2:
          break;
        
        default:
          cookieBehaviorValue = -1;
          dialogTextAppend = " " + this.getLocalizedString("Cookies3PartyDisabledYandexText");
          break;
      }
      
      var dialogText = this.getLocalizedFormattedString("CookiesDisabledText", [dialogTextAppend]);
      
      var prompter = this.nsIYa.promptService;
      var dummy = { value: false };
      if (prompter.confirmEx(window,
                             null,
                             dialogText,
                             prompter.STD_YES_NO_BUTTONS + prompter.BUTTON_POS_0_DEFAULT,
                             null, null, null, null, dummy) == 1) { // 1 == "No"
        return false;
      }
      
      if (cookieBehaviorValue != -1)
        this.nsIYa.setIntPref("network.cookie.cookieBehavior", 0);
      
      if (!this.nsIYa.isCookiesAllowedForHost(cookiesHostName))
        this.nsIYa.allowCookiesForHost(cookiesHostName);
    }
    
    this.nsIYa.initLoginProcess(document.getElementById("yasearch-username").value,
                                document.getElementById("yasearch-password").value,
                                document.getElementById("yasearch-store-password").checked,
                                true);
    
    return false;
  },
  
  toggleCollapsedView: function(aCollapsed) {
    var tabpanel = document.getElementById("login-tabpanel");
    var collapsed = typeof aCollapsed == "boolean" ? aCollapsed : !(tabpanel.getAttribute("collapsed") == "true");
    
    tabpanel.setAttribute("collapsed", collapsed);
    
    this.sizeToContent();
    
    this.setAboutServiceCollapsedState(collapsed);
  },
  
  handleWindowClick: function(aEvent) {
    var target = aEvent.originalTarget,
        targetHref;
    
    while (target &&
           "getAttribute" in target &&
           !(targetHref = target.getAttribute("href") || target.getAttribute("yahref"))) {
      target = target.parentNode;
    }
    
    if (targetHref) {
      targetHref = targetHref.replace(/\{user\}/g, this.nsIYa.username);
      
      var action = target.hasAttribute("yaLinkAction") ? target.getAttribute("yaLinkAction") : null;
      
      if (/\/mail\.yandex\.(ru|ua)\/messages$/.test(targetHref) &&
          this.nsIYa.getBoolPref("yasearch.mail.uri.open.new"))
      {
        targetHref += "?extra_cond=only_new";
      }
      else if (/\/lenta\.yandex\.(ru|ua)\/read\.xml$/.test(targetHref) &&
               this.nsIYa.getBoolPref("yasearch.feeds.uri.open.new"))
      {
        targetHref = targetHref.replace(/(read\.xml)/, 'un$1');
      }
      
      this.nsIYa.loadURI(targetHref, "tab", (action ? {action:action} : null));
      
      this.cancelDialog();
      
      return false;
    }
    
    return true;
  },
  
  checkAcceptButton: function() {
    var disabled = this.loginState >= this.LOGIN_STATES.REQUEST ||
                   document.getElementById("yasearch-username").textLength < 2 ||
                   document.getElementById("yasearch-password").textLength < 2;
    
    var acceptButton = document.documentElement.getButton("accept");
    if (acceptButton.disabled !== disabled) {
      acceptButton.disabled = disabled;
    }
    
    document.getElementById("login-button").disabled = disabled;
  },
  
  handleLoginEntered: function() {
    var pass = this.nsIYa.passwordManager.getStoredPassword(document.getElementById("yasearch-username").value);
    document.getElementById("yasearch-password").value = pass;
    document.getElementById("yasearch-store-password").checked = !!pass;
    
    this.checkAcceptButton();
  },
  
  getLocalizedString: function(aName) {
    return document.getElementById("yasearch-string-bundle-welcome").getString(aName);
  },
  
  getLocalizedFormattedString: function(aName, aStrArray) {
    return document.getElementById("yasearch-string-bundle-welcome").getFormattedString(aName, aStrArray, aStrArray.length);
  },
  
  _getHoverCellHelper: function(aEvent) {
    var row = {},
        col = {},
        obj = {};
    
    var docBoxObject = document.documentElement.boxObject;
    var x = aEvent.screenX - docBoxObject.screenX;
    var y = aEvent.screenY - docBoxObject.screenY;
    
    aEvent.originalTarget.parentNode.treeBoxObject.getCellAt(x, y, row, col, obj);
    
    return (row.value >= 0) ? { row: row.value, column: col.value.id } : null;
  },
  
  handleEvent: function(aEvent) {
    if (!aEvent.isTrusted)
      return;
    
    switch (aEvent.type) {
      case "mouseup":
        var rc = this._getHoverCellHelper(aEvent);
        if (rc) {
          if (rc.column && rc.column == "treecolAutoCompleteComment") {
            aEvent.stopPropagation();
            
            var login2remove = document.getElementById("yasearch-username").controller.getValueAt(rc.row);
            var rv = this.nsIYa.promptService.confirm(window,
                              this.getLocalizedString("LogginRemoveUserTitle"),
                              this.getLocalizedFormattedString("LogginRemoveUserMessage", [login2remove]));
            
            if (rv) {
              var password2remove = this.nsIYa.passwordManager.getStoredPassword(login2remove);
              this.nsIYa.passwordManager.removeUserData(login2remove);
              
              if (document.getElementById("yasearch-username").value == login2remove) {
                document.getElementById("yasearch-username").value = "";
                
                if (document.getElementById("yasearch-password").value == password2remove)
                  document.getElementById("yasearch-password").value = "";
                
                document.getElementById("yasearch-store-password").checked = false;
              }
              
              this.refreshHasSavedLoginsMode();
              this.checkAcceptButton();
            }
          }
        }
        break;
      
      case "mousemove":
        var rc = null;
        try {
          rc = this._getHoverCellHelper(aEvent);
        } catch(e) {}
        
        if (!rc)
          return;
        
        var onCommentColumn = (rc.column && rc.column == "treecolAutoCompleteComment") ? true : false;
        if (this.nsIYa.passwordManager.onHoverTreeUglyHack != onCommentColumn) {
          this.nsIYa.passwordManager.onHoverTreeUglyHack = onCommentColumn;
          document.getElementById("yasearch-username").popup.invalidate();
        }
        break;
    }
  },
  
  observe: function(aSubject, aTopic, aState) {
    switch (aTopic) {
      case "Ya-Login-State-Changed":
        this.handleLoginStateChanged();
        break;
      
      case "Ya-Refresh-Data":
        switch (aState) {
          case "allServices":
            var xulList = this.nsIYa.Counters.getUserServicesXUL();
            
            document.getElementById("tabbox-services").busy = false;
            
            if (xulList)
              this.nsIYa.DOMUtils.replaceChildNodes(xulList, document.getElementById("user-info-services-list"));
            
            this.sizeToContent();
            
            break;
          
          case "yaru-user-data":
            var yaruData = this.nsIYa.Counters.getYaruUserData().xml;
            
            var avatar = document.getElementById("user-info-avatar");
            avatar.holder.setAttribute("yahref", "http://{user}.ya.ru/");
            avatar.holder.setAttribute("yaLinkAction", "3470");
            avatar.avatarSrc = yaruData.avatar.toString() + "middle";
            
            document.getElementById("user-info-name").value = yaruData.title.toString() || this.nsIYa.username;
            document.getElementById("user-info-status").value = yaruData.mood.toString();
            
            break;
        }
        
        break;
      
      default:
        break;
    }
  },
  
  handleLoginStateChanged: function(aFromObserver) {
    var connectionStatus = 0;
    var lastStateIsRequest = document.getElementById("yasearch-connection-status").selectedIndex == 1;
    
    if (this.loginState == this.LOGIN_STATES.AUTH) {
      if (lastStateIsRequest) {
        // call "onCommand" for "callback" element
        if (this.callbackElementId) {
          var browser = this.nsIYa.getWindow("navigator:browser");
          if (browser && browser.Ya) {
            var elementToCall = browser.document.getElementById(this.callbackElementId);
            if (elementToCall && "doCommand" in elementToCall) {
              var clbckFn = elementToCall.id === "yasearch-bookmarks-button" ? // bookmarks wrkrnd
                                function() { browser.Ya.loadURI("zakladki.yandex.ru"); } :
                                function() { elementToCall.doCommand(); };
              
              new this.nsIYa.utils.G_Timer(clbckFn, 1000);
            }
          }
        }
        this.cancelDialog();
        return;
      }
      
      this.showUserPage();
      
    } else {
      switch (this.loginState) {
        case this.LOGIN_STATES.NO_AUTH:
          if (this._exitAfterLogout) {//"Exit" link
            document.documentElement.cancelDialog();
            return;
          }
          
          break;
        
        case this.LOGIN_STATES.REQUEST:
          connectionStatus = 1;
          break;
        
        case this.LOGIN_STATES.NET_ERROR:
          connectionStatus = lastStateIsRequest ? 3 : 0;
          break;
        
        case this.LOGIN_STATES.CAPTCHA_ERROR:
          if (lastStateIsRequest) {
            var prompter = this.nsIYa.promptService;
            
            var flags = prompter.BUTTON_POS_0 * prompter.BUTTON_TITLE_IS_STRING +
                        prompter.BUTTON_POS_1 * prompter.BUTTON_TITLE_IS_STRING +
                        prompter.BUTTON_POS_0_DEFAULT;
            
            var rv = prompter.confirmEx(window,
                                        this.getLocalizedString("CaptchaDialogTitle"),
                                        this.getLocalizedString("CaptchaDialogMsg"),
                                        flags,
                                        this.getLocalizedString("CaptchaDialogButtonOK"),
                                        this.getLocalizedString("CaptchaDialogButtonCancel"),
                                        null, null, {});//1 == CANCEL
            
            if (rv !== 1) {
              this.nsIYa.loadURI("https://passport.yandex.ru", "tab");
              this.cancelDialog();
              return;
            }
          }
          //~ break;
        
        default:
          if (lastStateIsRequest)
            connectionStatus = 2;
          break;
      }
      
      if (lastStateIsRequest && this.nsIYa.loginFail)
        connectionStatus = 4;
      
      this.showAuthPage();
    }
    
    this.setConnectionStatus(connectionStatus);
    
    var controlsDisabled = (this.loginState >= this.LOGIN_STATES.REQUEST);
    ["yasearch-username", "yasearch-password", "yasearch-store-password"]
    .forEach(function(aControlId) {
      document.getElementById(aControlId).disabled = controlsDisabled;
    })
  },
  
  setConnectionStatus: function(aStatusIndex) {
    document.getElementById("yasearch-connection-status").selectedIndex = aStatusIndex;
    this.sizeToContent();
  },
  
  refreshHasSavedLoginsMode: function() {
    document.getElementById("yasearch-username").setAttribute("yaHasSavedLogins", this.nsIYa.passwordManager.hasSavedLogins);
  },
  
  showAuthPage: function() {
    this.dialogContent.selectedIndex = 0;
    
    this.refreshHasSavedLoginsMode();
    
    if (document.getElementById("yasearch-username").value == "") {
      var username = this.nsIYa.getCharPref("yasearch.users.default");
      if (username) {
        document.getElementById("yasearch-username").value = username;
        document.getElementById("yasearch-password").value = this.nsIYa.passwordManager.getStoredPassword(username);
        document.getElementById("yasearch-store-password").checked = (document.getElementById("yasearch-password").value != "");
      }
    }
    
    this.checkAcceptButton();
  },
  
  showUserPage: function() {
    document.getElementById("user-info-avatar").removeAttribute("yahref");
    
    // set data from cache
    this.observe(null, "Ya-Refresh-Data", "allServices");
    this.observe(null, "Ya-Refresh-Data", "yaru-user-data");
    
    document.getElementById("tabbox-services").busy = true;
    
    this.dialogContent.selectedIndex = 1;
    
    // refresh data
    this.nsIYa.refreshHTTPData("allServices");
    this.nsIYa.Counters.refreshYaRuUserData();
  },
  
  _exitAfterLogout: false,
  
  logout: function(aExitAfterLogout) {
    const NOPROMPT_PREF_NAME = "yasearch.general.ui.mybar.logout.noprompt";
    var forgetMe = {value: false};
    var noprompt = this.nsIYa.getBoolPref(NOPROMPT_PREF_NAME);
    
    if (!noprompt) {
      var savedPass = !!(this.nsIYa.username && this.nsIYa.passwordManager.getStoredPassword(this.nsIYa.username));
      
      var prompts = this.nsIYa.promptService;
      var buttonFlags = prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_IS_STRING +
                        prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_IS_STRING +
                        prompts.BUTTON_POS_2 * prompts.BUTTON_TITLE_IS_STRING +
                        prompts.BUTTON_POS_0_DEFAULT;
      
      var answerBtnIndex = prompts.confirmEx(null,
                                             this.getLocalizedString("logOutTitle"),
                                             this.getLocalizedString("logOutConfirm"),
                                             buttonFlags,
                                             this.getLocalizedString("logOutYesPrompt"),
                                             this.getLocalizedString("logOutNoPrompt"),
                                             this.getLocalizedString("logOutNoAlwaysPrompt"),
                                             savedPass ? this.getLocalizedString("logOutForgetPass") : null,
                                             forgetMe);
      
      switch (answerBtnIndex) {
        case 0: // Yes
          break;
        
        case 1: // No
          return;//break
        
        case 2: // Yes, and don't ask again
          this.nsIYa.setBoolPref(NOPROMPT_PREF_NAME, true);
          break;
      }
    }
    
    this._exitAfterLogout = aExitAfterLogout;
    this.nsIYa.fireAfterLogOut(true, forgetMe.value);
  },
  
  onNewLoginClick: function(aEvent) {
    var url = "http://passport.yandex.ru/passport?mode=register";
    
    var clid4 = this.nsIYa.vendorData.clid4 || "";
    
    url += "&clid=" + clid4 +
           "&retpath=http%3A%2F%2Fclck.yandex.ru%2Fredir%2Fdtype%3Dstred%2Fpid%3D12%2Fcid%3D1737%2Fpath%3D" +
           clid4 + "%2F*";
    
    var serviceURL = "http://i.yandex.ru"
    var serviceData = this.nsIYa.Counters.getServiceLocalizedXML(this.aboutService);
    if (serviceData) {
      var afterRegURL = serviceData.afterregistration.toString() || serviceData.url.toString();
      if (afterRegURL)
        serviceURL = afterRegURL;
    }
    
    url += encodeURIComponent(serviceURL);
    
    this.onpenerYa.loadURI(url, aEvent, {action:3100});
    this.cancelDialog();
  }
}
