if (!YaPrefs) {
var YaPrefs = {
  nsIYa: Cc["@yandex.ru/yasearch;1"].getService(Ci.nsIYaSearch).wrappedJSObject,
  
  observerService: Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService),
  
  _initDone: false,
  
  savedSettings: {
    toolbarMode: {start: false, current: false},
    urbarCorrectorState: 2,
    showCyValue: false,
    showBloggersValue: false,
    highlighterEnabled: true,
    showSiteSearch: true,
    searchHistoryEnabled: true,
    showCityLabel: true
  },
  
  customizedElements: {},
  
  subOptionFileNames: {},
  
  get gBrowser() {
    if (!this._gBrowser) {
      var browser = this.nsIYa.getWindow("navigator:browser");
      if (!browser) {
        window.open("about:blank", "_blank");
        browser = this.nsIYa.getWindow("navigator:browser");
      }
      this._gBrowser = browser || null;
    }
    return this._gBrowser;
  },
  
  get gDocument() {
    return this.gBrowser.document;
  },
  
  get gYaToolbar() {
    if (!this._gYaToolbar)
      this._gYaToolbar = this.gDocument.getElementById("yasearch-bar");
    return this._gYaToolbar;
  },
  
  get gToolbox() {
    if (!this._gToolbox)
      this._gToolbox = this.gDocument.getElementById("navigator-toolbox");
    return this._gToolbox;
  },
  
  get _browsersReal() {
    return this.nsIYa.getWindows("navigator:browser");
  },
  
  get browsers() {
    if (!this._browsers || !this._browsers.length)
      this._browsers = this._browsersReal;
    
    return this._browsers;
  },
  
  get stringBundle() {
    return document.getElementById("yasearch-string-bundle-prefs");
  },
  
  handleEvent: function(aEvent) {
    switch (aEvent.type) {
      case "paneload":
        this.init(aEvent.target.id.split("yasearch-pane-")[1]);
        break;
      
      default:
        break;
    }
  },
  
  init: function(aType) {
    if (!this._initDone) {
      this._initDone = true;
      
      var helpButton = document.documentElement.getButton("extra2");
      helpButton.setAttribute("oncommand", "YaPrefs.loadHelpURI();");
      
      var subWinsDir = this.nsIYa.getContentDir();
      subWinsDir.append("preferences");
      subWinsDir.append("sub-wins");
      if (subWinsDir.exists() && subWinsDir.isDirectory()) {
        var fEnumerator = subWinsDir.directoryEntries;
        while (fEnumerator.hasMoreElements()) {
          var entry = fEnumerator.getNext().QueryInterface(Ci.nsIFile);
          if (entry.isFile()) {
            var name = entry.leafName;
            if (/.\.xul$/.test(name))
              this.subOptionFileNames[name.slice(0, -4)] = name;
          }
        }
      }
      
      this.observerService.addObserver(this, "Ya-Browser-OpenClose", false);
      
      this.savedSettings.urbarCorrectorState = this.nsIYa.KeyCorrector.currentState;
      
      ["showBloggersValue", "showCyValue", "highlighterEnabled",
       "showSiteSearch", "searchHistoryEnabled", "showCityLabel"]
      .forEach(function(aPrefName) {
        this.savedSettings[aPrefName] = this.nsIYa.prefs[aPrefName];
      }, this);
    }
    
    switch (aType) {
      case "main":
        this._readXBQuotesInterval();
        break;
      
      case "customize":
        var chkboxButtonsLabels = document.getElementById("general.ui.buttons.text");
        
        if (this.gYaToolbar && !chkboxButtonsLabels.hasAttribute("checked")) {
          var mode = this.gYaToolbar.getAttribute("mode");
          this.savedSettings.toolbarMode = {start: mode, current: mode};
          chkboxButtonsLabels.setAttribute("checked", mode == "icons" ? "false" : "true");
        }
        
        this.initElementsControl();
        
        break;
      
      case "notify":
        break;
      
      case "defence":
        //this.checkYandexHomePageButton();
        break;
      
      default:
        break;
    }
  },
  
  setButtonsInNewBrowser: function(aBrowser, aMustCheckState) {
    
    var defaultSet = this.gYaToolbar.getAttribute("defaultset");
    
    var doc = aBrowser.document,
        yaBar = doc.getElementById("yasearch-bar"),
        toolbox = doc.getElementById("navigator-toolbox");
    
    for each (var item in this.yaToolbarItems) {
      var pid = item.pid;
      
      if (pid == "yasearch-city" || pid == "yasearch-quotes")
        continue;
      
      var toolbarItem = doc.getElementById(item.pid);
      var visible = toolbarItem ? true : false;
      
      if (!visible) {
        var el = item.prev, found = false;
        while (el && !found) {
          found = yaBar.getElementsByAttribute("_yaPID", el.pid)[0] || false;
          el = el.prev;
        }
        
        if (found && found.nextSibling) {
          var prevFromDefault = ((new RegExp("([^,]*)," + pid).exec(defaultSet))||[])[1];
          
          if (prevFromDefault && (prevFromDefault == "spring" || prevFromDefault == "separator")) {
            prevFromDefault = "toolbar" + prevFromDefault;
            while (found.nextSibling && found.nextSibling.localName == prevFromDefault)
              found = found.nextSibling;
          }
        }
        
        var beforeElt = found ? (found.nextSibling ? found.nextSibling : false) :
                                (yaBar.firstChild ? yaBar.firstChild : false);
        toolbarItem = yaBar.insertItem(item.id, beforeElt ? beforeElt : null);
      }
      
      toolbarItem.setAttribute("yaCustomizedVisible", visible);
      toolbarItem.setAttribute("_yaPID", pid);
      
      item.toolbarItems.push(toolbarItem);
      
      if (aMustCheckState) {
        var chkbox = document.getElementById("checkbox-" + pid);
        if (chkbox)
          this.changeElementState(pid, chkbox.checked);
      }
    }
    
    if (aMustCheckState) {
      var cityItems = this.yaToolbarItems["yasearch-city"].cityToolbarItems;
      if (cityItems && cityItems.length > 0) {
        for each (var observer in this.nsIYa.yaCity._observers) {
          var state = observer.nodes[0].getAttribute("yaCustomizedVisible");
          for each (var node in observer.nodes) {
            if (cityItems.indexOf(node) == -1) {
              node.setAttribute("yaCustomizedVisible", state);
              node.setAttribute("_yaPID", "yasearch-city");
              cityItems.push(node);
            }
          }
        }
      }
    }
  },
  
  observe: function(aSubject, aTopic, aState) {
    switch (aTopic) {
      case "Ya-Browser-OpenClose":
        var currBrowsers = this._browsers;
        if (currBrowsers) {
          var realBrowsers = this._browsersReal;
          
          if (aState == "open") {
            for (var len_j = realBrowsers.length, j = len_j; j-- > 0;) {
              var exist = false;
              for (var len_i = currBrowsers.length, i = len_i; i-- > 0;) {
                if (realBrowsers[j] == currBrowsers[i]) {
                  exist = true;
                  break;
                }
              }
              
              if (!exist) {
                this.setButtonsInNewBrowser(realBrowsers[j], true);
                currBrowsers.push(realBrowsers[j]);
              }
            }
          }
          
          if (aState == "close") {
            for (var len_i = currBrowsers.length, i = len_i; i-- > 0;) {
              var exist = false;
              for (var len_j = realBrowsers.length, j = len_j; j-- > 0;) {
                if (realBrowsers[j] == currBrowsers[i]) {
                  exist = true;
                  break;
                }
              }
              
              if (!exist)
                currBrowsers.splice(i,1);
            }
            
            if (!currBrowsers.length)
              window.close();
          }
        }
        break;
    }
  },
  
  //checkYandexHomePageButton: function() {
    //document.getElementById("defence-set-yandex-as-homepage").disabled = !!(this.nsIYa.yandexHomePageValue === this.nsIYa.getBrowserHomePage());
  //},
  
  setYandexAsHomepage: function() {
    this.nsIYa.setHomePageUrl(true);
    //this.checkYandexHomePageButton();
  },
  
  loadHelpURI: function() {
    this.nsIYa.loadURI(this.nsIYa.getLocaleDependedUrl("HelpPageUrl"), "window", {action:3000});
  },
  
  syncHttpUpdateEnabled: function() {
    setTimeout(function() {
      var disabled = !document.getElementById("http.auto.enabled").checked;
      document.getElementById("http.update.interval").disabled = disabled;
      document.getElementById("http.update.weathertraff.interval").disabled = disabled;
      document.getElementById("http.update.xbquotes.interval").disabled = disabled;
    }, 1);
  },
  
  syncSoundnotification: function(type) {
    setTimeout(function() {
      var prfx = type + ".ui.soundnotification.",
          disabled = !document.getElementById(prfx + "enabled").checked;
      
      document.getElementById(prfx + "select").disabled = document.getElementById(prfx + "textbox").disabled = disabled;
      document.getElementById(prfx + "preview").disabled = !(!disabled && document.getElementById(prfx + "textbox").value != "");
    }, 1);
  },
  
  selectSound: function(type) {
    var nsIFilePicker = Ci.nsIFilePicker;
    var filepicker = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    
    filepicker.init(window, this.stringBundle.getString("ChooseASoundFile"), nsIFilePicker.modeOpen);
    filepicker.appendFilter(this.stringBundle.getString("ChooseASoundFilterWav"), "*.wav");
    filepicker.appendFilter(this.stringBundle.getString("ChooseASoundFilterAll"), "*.*");
    
    var ret = filepicker.show();
    if (ret == nsIFilePicker.returnOK) {
      document.getElementById(type + ".ui.soundnotification.textbox").value = filepicker.file.path;
      document.getElementById(type + ".ui.soundnotification.textbox").doCommand();
    }
    this.syncSoundnotification(type);
  },
  
  previewSound: function(type) {
    this.nsIYa.playSoundURL(document.getElementById(type + ".ui.soundnotification.textbox").value);
  },
  
  get yasearchOverlayToolbarItems() {
    delete this.yasearchOverlayToolbarItems;
    
    var overlayFile = this.nsIYa.getContentDir();
    overlayFile.append("yasearch.xul");
    
    var overlayData = this.nsIYa.readFile(overlayFile);
    var overlayDoc = this.nsIYa.domParser.parseFromString(overlayData, "text/xml");
    
    this.yasearchOverlayToolbarItems =
        Array.slice(overlayDoc.getElementsByTagName("toolbaritem"))
                   .filter(function(aToolbarItem) {
                             return /yasearch\-/.test(aToolbarItem.id);
                           });
    
    return this.yasearchOverlayToolbarItems;
  },
  
  get yaToolbarItems() {
    if (this.__yaToolbarItems)
      return this.__yaToolbarItems;
    
    var cityItems = [];
    
    for each (var observer in this.nsIYa.yaCity._observers) {
      for each (let node in observer.nodes) {
        node.setAttribute("yaCustomizedVisible", true);
        node.setAttribute("_yaPID", "yasearch-city");
        cityItems.push(node);
      }
    }
    
    var yaItems = {},
        prev = null,
        defaultSet = this.gYaToolbar.getAttribute("defaultset");
    
    for each (var item in this.yasearchOverlayToolbarItems) {
      var pid = item.id;
      
      var toolbarItem = this.gDocument.getElementById(pid);
      
      var visible = !!toolbarItem;
      
      if (!visible) {
        var el = prev, found = false;
        while (el && !found) {
          found = this.gYaToolbar._getElementByPID(el.pid);
          el = el.prev;
        }
        if (found && found.nextSibling) {
          var prevFromDefault = ((new RegExp("([^,]*)," + pid).exec(defaultSet))||[])[1];
          if (prevFromDefault && (prevFromDefault == "spring" || prevFromDefault == "separator")) {
            prevFromDefault = "toolbar" + prevFromDefault;
            while (found.nextSibling && found.nextSibling.localName == prevFromDefault)
              found = found.nextSibling;
          }
        }
        
        var beforeElt = found ? (found.nextSibling ? found.nextSibling : false) :
                                (this.gYaToolbar.firstChild ? this.gYaToolbar.firstChild : false);
        
        if (pid == "yasearch-city") {
          [,toolbarItem] = YaPrefs.nsIYa.yaOverlay.insertToolbarItem("yasearch-city", beforeElt, this.gBrowser);
        } else {
          toolbarItem = this.gYaToolbar.insertItem(pid, beforeElt ? beforeElt : null);
        }
      }
      
      if (!toolbarItem)
        continue;
      
      toolbarItem.setAttribute("yaCustomizedVisible", visible);
      toolbarItem.setAttribute("_yaPID", pid);
      
      yaItems[pid] = {
        toolbarItem: toolbarItem,
        toolbarItems: [toolbarItem],
        pid: pid,
        id: toolbarItem.id,// not "pid"!
        visible: visible,
        title: item.getAttribute("title"),
        prev: prev
      };
      
      prev = yaItems[pid];
    }
    
    if (cityItems.length > 0) {
      yaItems["yasearch-city"].cityToolbarItems = cityItems;
      yaItems["yasearch-city"].visible = true;
    }
    
    // Setup quotes
    let quotesVisible = true;
    let quotesItems = this._quotesToolbaritems;
    let quoteItem = quotesItems[0];
    
    if (!quotesItems.length) {
      quotesVisible = false;
      
      for each (var browser in this.browsers) {
        var bar = browser.document.getElementById("yasearch-bar");
        if (bar) {
          bar.insertItem("yasearch.cb-default-0", null);
          bar.insertItem("yasearch.cb-default-1", null);
        }
      }
      
      quotesItems = this._quotesToolbaritems;
      quoteItem = quotesItems[0];
    }
    
    if (quotesItems.length) {
      for each (let node in quotesItems) {
        node.setAttribute("yaCustomizedVisible", quotesVisible);
        node.setAttribute("_yaPID", "yasearch-quotes");
      }
      
      yaItems["yasearch-quotes"] = {
        toolbarItem: quoteItem,
        toolbarItems: quotesItems,
        pid: "yasearch-quotes",
        id: quoteItem.id,
        visible: quotesVisible,
        title: quoteItem.getAttribute("label"),
        prev: null
      };
    }
    
    this.__yaToolbarItems = yaItems;
    
    for each (var browser in this.browsers) {
      if (browser == this.gBrowser)
        continue;
      
      this.setButtonsInNewBrowser(browser, false);
    }
    
    return this.__yaToolbarItems;
  },
  
  openSubPrefWindow: function(aPid) {
    document.documentElement.openSubDialog(YaUtils.CHROME_CONTENT + "preferences/sub-wins/" + aPid + ".xul", "", null);
  },
  
  initElementsControl: function() {
    var XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
    
    var elementsBox = document.getElementById("yasearch.customize.elements");
    while (elementsBox.firstChild)
      elementsBox.removeChild(elementsBox.firstChild);
    
    this.__yaToolbarItems = null;
    this.customizedElements = this.yaToolbarItems;
    
    var rowSlot = 0;
    var currentRow = document.createElementNS(XULNS, "row");
    
    for each (var el in this.customizedElements) {
      if (el.pid == "yasearch-search" || el.pid == "yasearch-partner")
        continue;
      
      var box = document.createElementNS(XULNS, "hbox");
      
      var chBox = document.createElementNS(XULNS, "checkbox");
      chBox.setAttribute("checked", el.visible);
      chBox.setAttribute("label", el.title);
      chBox.setAttribute("oncommand", "YaPrefs.changeElementState('" + el.pid + "')");
      chBox.setAttribute("id", "checkbox-" + el.pid);
      box.appendChild(chBox);
      
      if (this.subOptionFileNames[el.pid]) {
        var b = document.createElementNS(XULNS, "vbox");
        b.setAttribute("disabled", !el.visible);
        b.setAttribute("onclick", "YaPrefs.openSubPrefWindow('" + el.pid + "')");
        box.appendChild(b);
      }
      currentRow.appendChild(box);
      
      if (++rowSlot == 2) {
        currentRow.setAttribute("align", "center");
        elementsBox.appendChild(currentRow);
        currentRow = document.createElementNS(XULNS, "row");
        rowSlot = 0;
      }
    }
    
    var i=0, bonusElems = document.getElementById("bonus-checkboxes").getElementsByTagName("checkbox");
    while (bonusElems.item(i)) {
      var el = bonusElems.item(i++).cloneNode(true);
      el.setAttribute("id", "checkbox-" + el.getAttribute("id"));
      currentRow.appendChild(el);
      
      if (++rowSlot == 2) {
        currentRow.setAttribute("align", "center");
        elementsBox.appendChild(currentRow);
        currentRow = document.createElementNS(XULNS, "row");
        rowSlot = 0;
      }
    }
    
    if (currentRow)
      elementsBox.appendChild(currentRow);
  },
  
  readUrlbarCorrectorState: function() {
    return this.nsIYa.KeyCorrector.currentState > 0 ? true : false;
  },
  
  writeUrlbarCorrectorState: function() {
    var corrector = document.getElementById("checkbox-yasearch-urlbar-corrector");
    var res = corrector && corrector.checked ? 2 : 0;
    this.nsIYa.KeyCorrector.currentState = res;
    return res;
  },
  
  changeElementState: function(aElementPid, aState) {
    var cElement = this.customizedElements[aElementPid];
    if (!cElement)
      return;
    
    var chkbox = document.getElementById("checkbox-" + aElementPid);
    if (typeof aState != "undefined")
      chkbox.checked = aState;
    
    var chk = chkbox.checked,
        elements = cElement.cityToolbarItems || cElement.toolbarItems;
    
    for each (var el in elements)
      el.setAttribute("yaCustomizedVisible", chk);
    
    var vbox = chkbox.nextSibling;
    if (vbox)
      vbox.setAttribute("disabled", !chk);
  },
  
  persistToolbarsSet: function(aToolbox) {
    if (!window.persistCurrentSets)
      return;
    
    var tb = aToolbox || this.gToolbox;
    var o = {}, n = {gToolboxChanged: true, gToolbox: tb, gToolboxDocument: tb.ownerDocument};
    
    for (var p in n) {
      o[p] = window[p];
      window[p] = n[p];
    }
    
    persistCurrentSets();
    
    for (var p in o)
      window[p] = o[p];
  },
  
  persistToolbars: function() {
    for each (var browser in this.browsers)
      this.persistToolbarsSet(browser.document.getElementById("navigator-toolbox"));
  },
  
  restoreDefaultSet: function() {
    let rv = this.nsIYa.promptService.confirm(window,
                                              this.stringBundle.getString("PreferencesTitle"),
                                              this.stringBundle.getString("RestoreDefaultSet"));
    if (!rv)
      return;
    
    Array.slice(document.documentElement.currentPane.getElementsByTagName("preferences"))
         .forEach(function(aPrefsElement) {
                    if (/#childprefs$/.test(aPrefsElement.id))
                      aPrefsElement.parentNode.removeChild(aPrefsElement);
                  });
    
    let nsIYa = this.nsIYa;
    let yaPrefs = nsIYa.prefs;
    let savedSettings = this.savedSettings;
    
    savedSettings.urbarCorrectorState = nsIYa.KeyCorrector.currentState = 2;
    savedSettings.showCyValue = yaPrefs.showCyValue = false;
    savedSettings.showBloggersValue = yaPrefs.showBloggersValue = false;
    savedSettings.showSiteSearch = yaPrefs.showSiteSearch = true;
    savedSettings.searchHistoryEnabled = yaPrefs.searchHistoryEnabled = true;
    savedSettings.showCityLabel = yaPrefs.showCityLabel = true;
    
    nsIYa.setBoolPref("yasearch.general.ui.mybar.logout.noprompt", false);
    
    nsIYa.setIntPref("yasearch.general.ui.bookmarks.action", 2);
    nsIYa.setBoolPref("yasearch.general.ui.bookmarks.showaddtofolderontop", true);
    nsIYa.yaBookmarks.yaruPrefs.set("yaruLiveWindowDisabled", false);
    
    savedSettings.highlighterEnabled = yaPrefs.highlighterEnabled = true;
    nsIYa.setBoolPref("yasearch.general.ui.highlighter.teleport", true);
    nsIYa.setBoolPref("yasearch.general.ui.highlighter.serp", true);
    
    nsIYa.resetPrefBranch("yasearch.general.ui.translate");
    
    for each (let item in this.customizedElements) {
      for each (let tbItem in (item.cityToolbarItems || item.toolbarItems)) {
        this._removeToolbarItem(tbItem);
      }
    }
    
    let defaultsetIds = this.gYaToolbar.getAttribute("defaultset").split(",");
    
    for each (let browser in this.browsers) {
      let bar = browser.document.getElementById("yasearch-bar");
      while (bar.firstChild)
        bar.removeChild(bar.firstChild);
      
      defaultsetIds.forEach(function(id) bar.insertItem(id));
      
      let searchbox = browser.document.getElementById("yasearchbox");
      if (searchbox) {
        let defWidth = parseInt(searchbox.getAttribute("yaDefaultWidth"),10);
        if (defWidth) {
          searchbox.setAttribute("width", defWidth);
          if ("updateWidthOnResize" in searchbox)
            searchbox.updateWidthOnResize();
        } else {
          ["width", "yaSHistoryWidth"].forEach(function(aAttrName) {
            if (this.hasAttribute(aAttrName))
              this.removeAttribute(aAttrName);
          }, searchbox);
        }
      }
      
      if (bar.collapsed) {
        bar.collapsed = false;
        browser.document.persist(bar.id, "collapsed");
      }
    }
    
    nsIYa.yaCity.updateObservers();
    nsIYa.yaCity.updateAllCityInfo();
    
    this.persistToolbars();
    this.initElementsControl();
  },
  
  changeToolbarMode: function() {
    var currMode = this.savedSettings.toolbarMode.current;
    if (currMode) {
      var setMode = false, chk = document.getElementById("general.ui.buttons.text").checked;
      if (chk && currMode == "icons")
        setMode = "full";
      else if (!chk && currMode != "icons")
        setMode = "icons";
      
      if (setMode) {
        for each (let browser in this.browsers) {
          let bar = browser.document.getElementById("yasearch-bar");
          if (bar)
            bar.setAttribute("mode", setMode);
        }
      }
      this.savedSettings.toolbarMode.current = setMode;
    }
  },
  
  // XB & Quotes
  _XBApplication: Cc["@yandex.ru/custombarcore;yasearch"].getService().wrappedJSObject.application,
  
  _quotesProtoId: "A78155FC-41D5-4304-BD60-A01D8C1FB9FA",
  
  get _quotesWidgetProto() {
    return this._XBApplication.widgetsRegistry.findProto(this._quotesProtoId);
  },
  
  get _quotesToolbaritems() {
    let toolbaritems = [];
    
    for each (let browser in this.browsers) {
      let nodes = this.nsIYa.DOMUtils.evaluateXPath(browser.document,
                  '//*[starts-with(@id,"yasearch.cb-' + this._quotesProtoId + '-")]');
      if (nodes)
        toolbaritems = toolbaritems.concat(nodes);
    }
    
    return toolbaritems;
  },
  
  _readXBQuotesInterval: function() {
    var updateEnabledCheckbox = document.getElementById("http.auto.enabled");
    var intervalInput = document.getElementById("http.update.xbquotes.interval");
    
    if (!(updateEnabledCheckbox && intervalInput))
      return;
    
    try {
      var settingNode = this._quotesWidgetProto.findSetting("update-interval");
      var intervalValue = parseInt(settingNode.getValue(),10) || 0;
      
      if ( !updateEnabledCheckbox.checked && (intervalValue == 0) )
        intervalValue = parseInt(settingNode.getDefaultValue(),10) || 0;
      
      intervalInput.value = intervalValue;
    }
    catch (e) {
      this.nsIYa.log(e.message);
    }
  },
  
  _applyQuotesSetting: function() {
    var updateEnabledCheckbox = document.getElementById("http.auto.enabled");
    var intervalInput = document.getElementById("http.update.xbquotes.interval");
    
    if (!(updateEnabledCheckbox && intervalInput))
      return;
    
    try {
      var updateIntervalValue = updateEnabledCheckbox.checked? parseInt(intervalInput.value,10): 0;
      this.nsIYa.log(updateIntervalValue);
      this._quotesWidgetProto.findSetting("update-interval").setValue(updateIntervalValue);
    }
    catch (e) {
      this.nsIYa.log(e.message);
    }
  },
  
  _removeToolbarItemHelper: function(aToolbarItem) {
    this._removeToolbarItemHelper =
      this.nsIYa.AppInfo.browser.isGreaterThenFx30 ?
        function(aToolbarItem) {
          try {
            if (aToolbarItem.parentNode) {
              var palette = aToolbarItem.parentNode.parentNode.palette;
              aToolbarItem = aToolbarItem.parentNode.removeChild(aToolbarItem);
              
              if (this.yaToolbarItems[aToolbarItem.id])
                palette.appendChild(aToolbarItem);
            }
          } catch (e) {
            YaPrefs.nsIYa.log(e);
          }
        }
        :
        function(aToolbarItem) {
          if (aToolbarItem.parentNode)
            aToolbarItem.parentNode.removeChild(aToolbarItem);
        };
    
    return this._removeToolbarItemHelper(aToolbarItem);
  },
  
  _removeToolbarItem: function(aToolbarItem) {
    aToolbarItem.removeAttribute("yaCustomizedVisible");
    
    try {
      //[2do] fx35 need that?
      if (aToolbarItem.id && ["yasearch-bookmarks", "yasearch-translate"].indexOf(aToolbarItem.id) != -1) {
        let toolbarbutton = aToolbarItem.firstChild;
        if (toolbarbutton && "yaDestroy" in toolbarbutton)
          toolbarbutton.yaDestroy();//fire XBL <destructor/> before .removeChild()
      }
    } catch(e) {}
    
    this._removeToolbarItemHelper(aToolbarItem);
  },
  
  beforeAccept: function() {
    for each (var sType in ["mail", "feeds"]) {
      var el = document.getElementById(sType + ".ui.soundnotification.textbox");
      if (el && el.value.replace(/\s/g,"") == "") {
        document.getElementById("yasearch." + sType + ".ui.soundnotification.enabled").value = false;
        document.getElementById("yasearch." + sType + ".ui.soundnotification.uri").value = "";
      }
    }
    
    for each (var browser in this.browsers) {
      browser.Ya.Bloggers.handleEvent({select: true});
      
      var doc = browser.document;
      
      var elems = doc.getElementsByAttribute("yaCustomizedVisible", "true");
      
      if (elems.length)
        while (elems[0])
          elems[0].removeAttribute("yaCustomizedVisible");
      
      elems = doc.getElementsByAttribute("yaCustomizedVisible", "false");
      
      if (elems.length)
        while (elems[0])
          this._removeToolbarItem(elems[0]);
    }
    
    this._applyQuotesSetting();
    
    this.accepted = true;
    return true;
  },
  
  beforeUnload: function() {
    window.removeEventListener("paneload", YaPrefs, true);
    
    if (document.documentElement.instantApply && !this.accepted) {
      this.accepted = true;
      this.beforeAccept();
    }
    
    var tbMode = this.savedSettings.toolbarMode;
    if (tbMode.current != tbMode.start) {
      var mode = this.accepted ? tbMode.current : tbMode.start;
      for each (var browser in this.browsers) {
        let bar = browser.document.getElementById("yasearch-bar");
        if (bar) {
          bar.setAttribute("mode", mode);
          bar.ownerDocument.persist("yasearch-bar", "mode");
        }
      }
    }
    
    if (this.accepted) {
      //if (this.nsIYa.isLogin && this.nsIYa.isCountersAutoUpdateEnabled)
        //this.nsIYa.refreshHTTPData("mailAndFeeds");
      
    } else {
      if (this.savedSettings.urbarCorrectorState !== this.nsIYa.KeyCorrector.currentState)
        this.nsIYa.KeyCorrector.currentState = this.savedSettings.urbarCorrectorState;
      
      for each (let item in this.customizedElements) {
        if (item.visible == false || (item.cityToolbarItems && item.cityToolbarItems.length > 0)) {
          for each (let tbItem in item.toolbarItems) {
            this._removeToolbarItem(tbItem);
          }
          
          if (item.cityToolbarItems) {
            for each (let tbItem in item.cityToolbarItems) {
              if (tbItem.getAttribute("yaCustomizedVisible") == "false")
                this._removeToolbarItem(tbItem);
            }
          }
        }
      }
      
      for each (let browser in this.browsers) {
        let elems = browser.document.getElementsByAttribute("yaCustomizedVisible", "*");
        while (elems[0])
          elems[0].removeAttribute("yaCustomizedVisible");
      }
      
      ["showBloggersValue", "showCyValue", "highlighterEnabled",
       "showSiteSearch", "searchHistoryEnabled", "showCityLabel"]
      .forEach(function(aPrefName) {
        if (this.savedSettings[aPrefName] !== this.nsIYa.prefs[aPrefName])
          this.nsIYa.prefs[aPrefName] = this.savedSettings[aPrefName];
      }, this)
    }
    
    this.nsIYa.yaCity.updateObservers();
    
    this.persistToolbars();
    
    for each (let browser in this.browsers) {
      browser.Ya.updateFeedsAttribute();
      
      let bloggers = browser.Ya.Bloggers;
      if (bloggers)
        bloggers.checkWindowState();
    }
    
    this.nsIYa.refreshCYInAllBrowsers();
    
    this.observerService.notifyObservers(null, "Ya-Refresh-Login-Status", false);
    
    this.observerService.removeObserver(this, "Ya-Browser-OpenClose");
  }
};

window.addEventListener("paneload", YaPrefs, true);
}