<?xml version="1.0"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:param name="serviceType" select="'bar'"/>
<xsl:param name="serviceURL" select="''"/>
<xsl:param name="serviceURLAction" select="0"/>

<xsl:template match="services">
  <xsl:apply-templates select="service[@name=$serviceType]"/>
</xsl:template>

<xsl:template match="service">
  <vbox serviceTitle="{title}">
    <hbox>
      <description id="about-service-link" value="{title}" class="header-desc">
        <xsl:if test="string($serviceURL)">
          <xsl:attribute name="yahref">
            <xsl:value-of select="$serviceURL"/>
          </xsl:attribute>
        </xsl:if>
        <xsl:if test="number($serviceURLAction) &gt; 0">
          <xsl:attribute name="yaLinkAction">
            <xsl:value-of select="$serviceURLAction"/>
          </xsl:attribute>
        </xsl:if>
      </description>
      <description value="&#160;&#8212;" class="header-desc" style="font-weight: normal;"/>
    </hbox>
    
    <description>
      <xsl:value-of select="description/title"/>
    </description>
    
    <description class="header-desc">
      <xsl:value-of select="description/text"/>
    </description>
    
    <grid flex="1">
      <rows><row/></rows>
      <columns>
        <xsl:for-each select="about/text">
          <column flex="1" pack="center">
            <hbox flex="1">
              <vbox pack="center">
              <image>
                <xsl:attribute name="src">
                  <xsl:value-of select="concat('chrome://yasearch/content/services/mybar/', $serviceType, '/')"/>
                  <xsl:number/>
                  <xsl:text>.png</xsl:text>
                </xsl:attribute>
              </image>
              </vbox>
              <vbox flex="1" pack="center">
                <description>
                  <xsl:value-of select="."/>
                </description>
              </vbox>
            </hbox>
          </column>
        </xsl:for-each>
      </columns>
    </grid>
  </vbox>
</xsl:template>

</xsl:stylesheet>