var gYaUServices = {
  _servicesFileName: "services.mybar.xml",
  _servicesFileURL: "http://export.yandex.ru/xml/services.mybar.xml",
  _countersURL: "http://export.yandex.ru/counters-js.xml",
  
  _servicesFileWrapper: null,
  
  _timedHTTPRequester: null,
  
  _timedHTTPRequesterCallback: function(aResponseData) {
    var data = gYaSearchService.safeE4Xml(aResponseData, null, ["services"]);
    return (data && data..service.length() > 5) ? aResponseData : null;
  },
  
  _init: function() {
    OBSERVER_SERVICE.addObserver(this, "quit-application-granted", false);
    OBSERVER_SERVICE.addObserver(this, "profile-after-change", false);
    OBSERVER_SERVICE.addObserver(this, "profile-before-change", false);
  },
  
  _uninit: function() {
    OBSERVER_SERVICE.removeObserver(this, "profile-before-change");
    OBSERVER_SERVICE.removeObserver(this, "profile-after-change");
    OBSERVER_SERVICE.removeObserver(this, "quit-application-granted");
  },
  
  _profileInit: function() {
    this._timedHTTPRequester = new G_TimedHTTPRequester(
        "servicesmybar", this._servicesFileURL, this._servicesFileName,
        this._timedHTTPRequesterCallback.bind(this)// default: 2 weeks, 1 hour
    );
    
    this._servicesFileWrapper = new G_HTTPFileWrapper(this._servicesFileName, ["services"]);
    this.servicesXMLData;
  },
  
  _profileUninit: function() {
    this._servicesFileWrapper = null;
  },
  
  observe: function(aSubject, aTopic, aData) {
    switch (aTopic) {
      case "quit-application-granted":
        this._uninit();
        break;
      
      case "profile-after-change":
        this._profileInit();
        break;
      
      case "profile-before-change":
        this._profileUninit();
        break;
    }
  },
  
  /*************************************************************
   * Counters
   *************************************************************/
  
  _data: {},
  
  _SERVICES_DATA: {
    mail:    { sid: 43, isCounter: true },
    lenta:   { sid: 44, isCounter: true, notifyUser: true },
    money:   { sid: 45, isCounter: true },
    fotki:   { sid: 46, isCounter: true, alias: "fotos"},
    yaru:    { sid: 47, isCounter: true, alias: "blogs"},
    moikrug: { sid: 48, isCounter: true}
  },
  
  get SERVICES_DATA() {
    return this._SERVICES_DATA;
  },
  
  getServiceAlias: function(aServiceName) {
    var alias = aServiceName;
    
    if (aServiceName in this.SERVICES_DATA)
      alias = this.SERVICES_DATA[aServiceName].alias || aServiceName;
    
    return alias;
  },
  
  _errorTimeout: 0,
  
  get errorTimeout() {
    var timeout = (this._errorTimeout || 1) * Math.max(5, gYaSearchService.getIntPref("yasearch.http.update.interval"));
    return Math.min(15, timeout) * MIN_SEC;
  },
  
  set errorTimeout(val) {
    this._errorTimeout = (val === null) ? 0 : Math.min(3, Math.max(1, val));
    return this._errorTimeout;
  },
  
  _error: false,
  
  get error() {
    return this._error;
  },
  
  set error(val) {
    this._error = val;
    return this._error;
  },
  
  getCounterError: function(aInboxString) {
    var res, sandbox = new Components.utils.Sandbox(this._countersURL);
    try {
      res = Components.utils.evalInSandbox(aInboxString + ' inboxCounters', sandbox);
    } catch(e) {}
    
    var error = false;
    if (res && typeof(res) === 'object' && res.toSource && res.toSource() == '({})') {
      error = { type: 'noauth' };
      this.handleNoAuth();
    } else if (!res || typeof(res) !== 'object' || ('error' in res) || !(('login' in res) && ('services' in res))) {
      error = { type: 'error' };
    }
    
    this.error = error;
    
    this.errorTimeout = this.error ? (this._errorTimeout + 1) : null;
    
    return this.error;
  },
  
  evalInboxString: function(aInboxString) {
    var res, sandbox = new Components.utils.Sandbox(this._countersURL);
    try {
      res = Components.utils.evalInSandbox(aInboxString + ' inboxCounters', sandbox);
    } catch(e) {}
    
    return res;
  },
  
  getInboxObject: function(aInboxString, aCounterName) {
    var res;
    
    if (!this.error) {
      var sandbox = new Components.utils.Sandbox(this._countersURL);
      try {
        res = Components.utils.evalInSandbox(aInboxString + ' inboxCounters', sandbox);
        
        if (aCounterName)
          res = res.services[aCounterName];
      
      } catch(e) {}
    }
    
    return (typeof res === "object" && ('error' in res)) ? res : {error:10};
  },
  
  get login() {
    return gYaSearchService.username;
  },
  
  getSID: function(aType) {
    return this.SERVICES_DATA[aType].sid;
  },
  
  getURLForSID: function(aTypes) {
    var params = [];
    
    if (aTypes === 'allCounters') {
      var servicesData = this.SERVICES_DATA;
      var buttonsInfo = gYaSearchService.buttonsInfo;
      
      if (buttonsInfo) {
        for (var service in servicesData) {
          var sData = servicesData[service];
          if (sData.isCounter && sData.sid && buttonsInfo[service]) {
              params.push("services=" + sData.sid);
          }
        }
      }
    } else if (aTypes === 'allServices') {
      params.push("services=all");
    } else {
      for each (var type in aTypes)
        params.push("services=" + this.getSID(type));
    }
    
    if (!params.length)
      return false;
    
    return this._countersURL + "?" + params.join("&").replace(/'/g, "\\'");
  },
  
  appendUserSessionData: function(aLogin, aXmlServiceData, aXmlYaruData) {
    if (!this._data[aLogin])
      this._data[aLogin] = {};
    
    var data = this._data[aLogin];
    for each (var serviceNode in aXmlServiceData.*) {
      var service = serviceNode.name();
      if (!data[service])
        data[service] = this.newDataObject;
      
      data[service].permCounter = gYaSearchService.parseIntFromStr(serviceNode.@pcounter.toString());
      data[service].inboxData.error = serviceNode.@perror.toString() === "0" ? 0 : 10;
    }
    
    this.setYaruUserData({xml: aXmlYaruData, error: null}, aLogin);
  },
  
  getUserSessionDataForFlush: function(aLogin) {
    var counters = new XML('<counters/>');
    
    if (this._data && this._data[aLogin]) {
      var loginData = this._data[aLogin];
      
      for (var serviceName in loginData) {
        var servData = loginData[serviceName];
        var permCounter = servData.permCounter;
        var permError = (typeof(servData.inboxData) === 'object' && 'error' in servData.inboxData) ?
                            servData.inboxData.error : 10;
        
        if (permCounter || permError === 0) {
          counters[serviceName].@pcounter = permCounter;
          counters[serviceName].@perror = permError;
        }
      }
    }
    
    return [counters, this.getYaruUserData(aLogin).xml];
  },
  
  clear: function() {
    this._data = {};
  },
  
  clearData: function(aType) {
    this.setData(aType, null);
  },
  
  setDataFromInbox: function(aType, aInboxString) {
    var counterName = this.getServiceAlias(aType);
    this.setData(aType, this.getInboxObject(aInboxString, counterName));
  },
  
  setData: function(aType, aData) {
    var login = this.login;
    
    if (!this._data[login])
      this._data[login] = {};
    
    if (aData === null) {
      //~ delete this._data[login][aType];
    } else if (/^::/.test(aType)) {
      this._data[login][aType] = aData;
    } else {
      if (!this._data[login][aType])
        this._data[login][aType] = this.newDataObject;
      
      var data = this._data[login][aType];
      data.inboxData = aData;
      
      if (aData.error === 0) {
        var counterValue = parseInt(aData.count, 10) || 0;
        
        if (aType in this.SERVICES_DATA && this.SERVICES_DATA[aType].notifyUser) {
          var cDiff = counterValue - data.permCounter;
          if (cDiff != 0 && counterValue > 0) {
            gYaSearchService.notifyAboutNewItems(aType, cDiff > 0 ? cDiff : counterValue);
          }
        }
        
        data.permCounter = counterValue;
        data.lastVisited = G_TIME_NOW;
      }
    }
  },
  
  handleError: function() {
    this.handleNoAuth();
    this.getUserSessionDataForFlush(this.login);//~ ?
  },
  
  handleNoAuth: function() {
    gYaSearchService.mailCounter = 0;
    gYaSearchService.mailDOMMenuDoc = false;
    
    for (var service in this.SERVICES_DATA) {
      this.setData(service, {error:10});
    }
  },
  
  getData: function(aType, aLogin) {
    var login = aLogin || this.login;
    
    if (login && this._data[login] && this._data[login][aType])
      return this._data[login][aType];
    
    return null;
  },
  
  get newDataObject() {
    return {
      permCounter: 0,
      lastVisited: 0,
      inboxData: {error:10}
    }
  },
  
  getCount: function(aType, aProp) {
    var data = this.getInboxData(aType);
    
    if (!(data && data.error === 0))
      return null;
    
    var cProp = aProp || "count";
    
    switch (cProp) {
      case "count":
      case "comments":
        break;
      
      default:
        return null;
    }
    
    return (cProp in data) ? data[cProp] : null;
  },
  
  getInboxData: function(aType) {
    var data = this.getData(aType);
    return (data && data.inboxData) ? data.inboxData : null;
  },
  
  getXULNode: function(aType) {
    return gYaSearchService.getDOMDocContent("counter-" + aType, this.getXMLData(aType));
  },
  
  getXMLData: function(aType) {
    var login = this.login;
    
    var data = this.getInboxData(aType);
    var xmlData = new XML('<counter><data/></counter>');
    
    if (login) {
      xmlData.@login = login;
      
      for (var prop in data) {
        xmlData.data['@' + prop] = data[prop];
      }
    }
    
    return gYaSearchService.domParser.parseFromString(xmlData.toSource(), "text/xml");
  },
  
  setAllServicesError: function(aIsError, aNotifyObservers) {
    this.setData("::allServices", {error: !!aIsError});
    
    if (aNotifyObservers)
      OBSERVER_SERVICE.notifyObservers(null, "Ya-Refresh-Data", "allServices");
  },
  
  setDataFromJS: function(aSourceText) {
    var res, sandbox = new Components.utils.Sandbox(this._countersURL);
    try {
      res = Components.utils.evalInSandbox(aSourceText + ' inboxCounters', sandbox);
    } catch(e) {}
    
    var error = false;
    if (res && typeof(res) === 'object' && res.toSource && res.toSource() == '({})') {
      error = { type: 'noauth' };
      this.handleNoAuth();
    } else if (!res || typeof(res) !== 'object' || ('error' in res) || !(('login' in res) && ('services' in res))) {
      error = { type: 'error' };
    }
    
    this.setAllServicesError(!!error, false);
    
    if (!error) {
      var js = res.services;
      for (var serviceName in js) {
        var service = js[serviceName];
        if (typeof(service) === 'object' && 'error' in service) {
          this.setDataFromInbox(serviceName, aSourceText);
        }
      }
    } else {
      this.clear();
    }
  },
  
  getServicesXML: function() {
    var servicesXML = this._servicesFileWrapper.mergedContent;
    
    if (!servicesXML)
      return null;
    
    // replace "{user}" by current username in all text nodes
    for each (var node in servicesXML.service..*.(!function::hasComplexContent() && /\{user\}/.test(function::text())))
      node.setChildren(node.text().toString().replace(/\{user\}/g, this.login));
    
    return servicesXML;
  },
  
  getServicesLocalizedXML: function() {
    var servicesXML = this.getServicesXML();
    
    if (!servicesXML)
      return null;
    
    var currentLang = gYaSearchService.localeTld;
    var defaultLang = "ru";
    
    for each (var service in servicesXML.service) {
      for each (var serviceNode in service.*) {
        var nodes = service[serviceNode.name()];
        if (nodes.length() > 1) {
          var node = nodes.(function::attribute('lang') == currentLang)[0] ||
                     nodes.(function::attribute('lang').length() == 0)[0] ||
                     nodes.(function::attribute('lang') == defaultLang)[0];
          
          if (node) {
            delete service[serviceNode.name()]
            service.* += node;
          }
        }
      }
    }
    
    return servicesXML;
  },
  
  getServiceLocalizedXML: function(aServiceName) {
    var servicesXML = this.getServicesLocalizedXML();
    if (!servicesXML)
      return null;
    
    var serviceXML = servicesXML.service.(function::attribute('name') == aServiceName)[0];
    return serviceXML || null;
  },
  
  getUserServicesXUL: function() {
    var servicesXML = this.getServicesXML();
    
    if (!servicesXML)
      return null;
    
    var i = 0, sortArr = [];
    
    for each (var service in servicesXML.service) {
      var inboxData = this.getInboxData(service.@name);
      
      service.@sorthelper = i++;//sort order; helper for fx2
      service.@error = 30;//not used
      
      if (inboxData) {
        // error == 40 - "hidden" money
        service.@error = inboxData.error == 40 ? 0 : inboxData.error;// == 10 ? 30 : inboxData.error;
        if ("count" in inboxData)
          service.@count = inboxData.count;
      }
      
      sortArr.push(service);
    }
    
    delete servicesXML.service;
    
    sortArr.sort(function(a,b) {
      var aE = a.@error.toString(), bE = b.@error.toString();
      var aS = parseInt(a.@sorthelper,10), bS = parseInt(b.@sorthelper,10);
      return (aE > bE) ? 1 : (aE < bE) ? -1 : (aS > bS ? 1 : (aS < bS ? -1 : 0));
    });
    
    for each (var a in sortArr)
      servicesXML.* += a;
    
    return gYaSearchService.getDOMDocContent2("services/mybar/uservices.xsl", servicesXML, {});
  },
  
  /* YaRu */
  getYaruUserData: function(aLogin) {
    return this.getData("::yaru", aLogin) || { xml: <yaru/>, error: null };
  },
  
  setYaruUserData: function(aData, aLogin) {
    var login = aLogin || this.login;
    
    if (!this._data[login])
      this._data[login] = {};
    
    if (!aData.xml)
      aData.xml = <yaru/>;
    
    this._data[login]["::yaru"] = aData;
    
    return this.getYaruUserData();
  },
  
  refreshYaRuUserData: function() {
    gYaSearchService.xmlHttpRequest("http://export.yandex.ru/yaru-info.xml?" + getNCRndStr(),
                             { callbackFunc: this.refreshYaRuUserDataCallback.bind(this) });
  },
  
  refreshYaRuUserDataCallback: function(aReq) {
    var error = null;
    
    if (gYaSearchService.isReqError(aReq)) {
      error = "lost_connection";
    } else if (!this.login) {
      error = "auth_required";
    }
    
    if (!error) {
      this.setYaruUserData({
        xml: gYaSearchService.safeE4Xml(aReq.target.responseText.replace(/[\r\n]/g, ""), null, "yaru"),
        error: error}
      )
    }
    
    OBSERVER_SERVICE.notifyObservers(null, "Ya-Refresh-Data", "yaru-user-data");
  }
}

gYaUServices._init();