<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "chrome://yasearch/locale/yasearch.dtd">

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:param name="cbl" select="'{'"/>
<xsl:param name="cbr" select="'}'"/>

<xsl:param name="addToFolderOnTop" select="true"/>

<!-- page/*[1] - for <err> -->
<xsl:template match="page/*[1]">
  <menupopup id="yasearch-bookmarks-menupopup"
             ondraggesture="nsDragAndDrop.startDrag(event, YaBookmarksUtils)"
             contextmenu="yaBookmarksPopup"
             tooltip="yasearch-bookmarks-tooltip">
    <menuitem label="&yasearch.bookmarks.reload.label;"
              oncommand="Ya.nsIYa.manualRefreshHTTPData('bookmarks')"/>
    <menuseparator/>
    <menuitem label="&yasearch.bookmarks.add.page.label;" anonid="menuitem-add"
              oncommand="document.getElementById('yasearch-bookmarks-button')._doCommand(this)"/>
    <menuitem label="&yasearch.bookmarks.edit.bookmark.label;" anonid="menuitem-edit"
              oncommand="document.getElementById('yasearch-bookmarks-button')._doCommand(this)"/>
    <menuseparator/>
    <menuitem label="&yasearch.bookmarks.open.label;" oncommand="Ya.loadURI('zakladki.yandex.ru', event, {$cbl}action:1900{$cbr})"/>
    
    <xsl:if test="count(./folder|./links/link) &gt; 0">
      <menuseparator/>
    </xsl:if>
    
    <xsl:apply-templates/>
  </menupopup>
</xsl:template>

<xsl:template match="folder">
  <menu container="true" class="menu-iconic bookmark-item" label="{@name}" yafolderid="{@id}">
    <xsl:attribute name="descr">
      <xsl:value-of select="descr"/>
    </xsl:attribute>
    <menupopup contextmenu="yaBookmarksPopup">
      <xsl:if test="$addToFolderOnTop != false">
        <xsl:apply-templates select="." mode="addMenuitem"/>
      </xsl:if>
      
      <xsl:apply-templates select="folder"/>
      <xsl:apply-templates select="links"/>
      
      <xsl:if test="count(links/link) &gt; 1">
        <menuseparator/>
        <menuitem label="&yasearch.bookmarks.openAllInTabs.label;"
                  accesskey="&yasearch.bookmarks.openAllInTabs.accesskey;"
                  oncommand="YaBookmarksUtils.openAllInTabs(event);"/>
      </xsl:if>
      
      <xsl:if test="$addToFolderOnTop = false">
        <xsl:apply-templates select="." mode="addMenuitem"/>
      </xsl:if>
      
    </menupopup>
  </menu>
</xsl:template>

<xsl:template match="folder" mode="addMenuitem">
  <xsl:if test="$addToFolderOnTop = false">
    <xsl:if test="count(./folder|./links/link) &gt; 0">
      <menuseparator/>
    </xsl:if>
  </xsl:if>
  
  <menuitem class="menuitem-iconic bookmark-item yasearch-add-page-to-folder"
            label="&yasearch.bookmarks.add.pageToFolder.label;"
            accesskey="&yasearch.bookmarks.add.pageToFolder.accesskey;"
            oncommand="Ya.addBookmark({@id});"/>
  
  <xsl:if test="$addToFolderOnTop != false">
    <xsl:if test="count(./folder|./links/link) &gt; 0">
      <menuseparator/>
    </xsl:if>
  </xsl:if>
</xsl:template>

<xsl:template match="links">
  <xsl:apply-templates select="link"/>
</xsl:template>

<xsl:template match="links/link">
  <menuitem yalinkid="{@id}" class="menuitem-iconic bookmark-item statusurl"
            label="{@name}" statustext="{@url}"
            oncommand="Ya.loadURI('{@url}', event, {$cbl}action:1910{$cbr});"
            onload="YaBookmarksUtils.setFaviconForURL('{@url}',this)">
    <xsl:attribute name="descr">
      <xsl:value-of select="descr"/>
    </xsl:attribute>
  </menuitem>
</xsl:template>

</xsl:stylesheet>