<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "chrome://yasearch/locale/bloggers/bloggers.dtd">

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:template match="page">
  <vbox flex="1">
    <xsl:choose>
      <xsl:when test="number(@count) &gt; 0">
        <yaclickscrollbox id="yasearch-blogger-content-scroll" orient="vertical" flex="1">
          <xsl:apply-templates select="user"/>
        </yaclickscrollbox>
        <hbox id="yasearch-blogger-getmore-link" pack="center">
          <label value="&yasearch.bloggers.openLink.label.small;"
                 onclick="(window.Ya || window).Bloggers.openLink('tab');"/>
        </hbox>
      </xsl:when>
      <xsl:otherwise>
        <vbox flex="1" align="center" valign="middle">
          <label value="&yasearch.bloggers.nodata.label;"/>
        </vbox>
      </xsl:otherwise>
    </xsl:choose>
  </vbox>
</xsl:template>

<xsl:template match="user">
  <hbox tooltip="yasearch-bloggers-window-tooltip">
    <xsl:attribute name="url">
      <xsl:value-of select="url"/>
    </xsl:attribute>
    
    <vbox>
      <hbox pack="center">
        <xsl:apply-templates select="img"/>
      </hbox>
    </vbox>
    <vbox class="ya-blogger-text" flex="1">
      <hbox>
        <label flex="1" crop="end" class="ya-blogger-user">
          <xsl:attribute name="value">
            <xsl:value-of select="username"/>
          </xsl:attribute>
        </label>
        <spacer/>
        <label crop="end" class="ya-blogger-time">
          <xsl:attribute name="value">
            <xsl:value-of select="date"/>
          </xsl:attribute>
        </label>
      </hbox>
      <description>
        <xsl:value-of select="subject"/>
      </description>
      <description class="ya-blogger-snipp">
        <xsl:value-of select="snippet"/>
      </description>
    </vbox>
  </hbox>
</xsl:template>

<xsl:template match="img">
  <image align="center" valign="top">
    <xsl:attribute name="src">
      <xsl:value-of select="@src"/>
    </xsl:attribute>
    <xsl:attribute name="width">
      <xsl:value-of select="@width"/>
    </xsl:attribute>
    <xsl:attribute name="height">
      <xsl:value-of select="@height"/>
    </xsl:attribute>
  </image>
</xsl:template>

</xsl:stylesheet>