<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY % yaBrandDTD SYSTEM "chrome://yasearch/locale/yasearch.dtd">
<!ENTITY % yaCityDTD SYSTEM "chrome://yasearch/locale/city/city.dtd">
%yaBrandDTD;
%yaCityDTD;
]>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:template match="/">
  <vbox>
    <hbox pack="center">
      <label value="&yasearch.city.traffic.label;" style="font-weight: bold"/>
    </hbox>
    
    <xsl:choose>
      <xsl:when test="info/traffic/level">
        <xsl:apply-templates select="info/traffic"/>
      </xsl:when>
      <xsl:otherwise>
        <label value="&yasearch.city.city.nodata.label;"/>
      </xsl:otherwise> 
     </xsl:choose>
  </vbox>
</xsl:template>

<xsl:template match="traffic">
  <hbox>
    <hbox class="yaTooltipIcon" yaTrafficIcon="{icon}" align="center" valign="top">
      <image/>
    </hbox>
    
    <vbox>
      <hbox pack="center">
        <label value="{title}" style="font-weight: bold"/>
      </hbox>
      
      <grid flex="1">
        <columns><column/><column flex="1"/></columns>
        <rows>
          <xsl:if test="level">
            <row>
              <label value="&yasearch.city.traffic.level.label;:" style="text-align:right;"/>
              <label value="{level}"/>
            </row>
          </xsl:if>
          
          <xsl:if test="hint">
            <row>
              <label value="&yasearch.city.traffic.hint.label;:" style="text-align:right;"/>
              <label value="{hint}"/>
            </row>
          </xsl:if>
          
          <xsl:if test="length and number(level) &gt; 1">
            <row>
              <label value="&yasearch.city.traffic.length.label;:" style="text-align:right;"/>
              <label value="{length} &yasearch.city.traffic.length.km.label;"/>
            </row>
          </xsl:if>
        </rows>
      </grid>
    </vbox>
  </hbox>
</xsl:template>

</xsl:stylesheet>