<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY % yaBrandDTD SYSTEM "chrome://yasearch/locale/yasearch.dtd">
<!ENTITY % yaCityDTD SYSTEM "chrome://yasearch/locale/city/city.dtd">
%yaBrandDTD;
%yaCityDTD;
]>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:template match="/">
  <vbox>
    <hbox pack="center">
      <label value="&yasearch.city.weather.label;" style="font-weight: bold"/>
    </hbox>
    
    <xsl:choose>
      <xsl:when test="info/weather/day/title">
        <xsl:apply-templates select="info/weather/day"/>
      </xsl:when>
      <xsl:otherwise>
        <label value="&yasearch.city.city.nodata.label;"/>
      </xsl:otherwise> 
     </xsl:choose>
  </vbox>
</xsl:template>

<xsl:template match="day">
  <hbox>
    <hbox class="yaTooltipIcon" align="center" valign="top">
      <image src="{day_part/image}"/>
    </hbox>
    
    <vbox>
      <hbox pack="center">
        <label value="{title}, {country}" style="padding-right:2em; font-weight: bold"/>
      </hbox>
      
      <grid flex="1">
        <columns><column/><column flex="1"/></columns>
        <rows>
          <xsl:if test="day_part/weather_type">
            <row>
              <label value="&yasearch.city.weather.label;:" style="text-align:right;"/>
              <label value="{day_part/weather_type}"/>
            </row>
          </xsl:if>
          <xsl:if test="day_part/temperature">
            <row>
              <label value="&yasearch.city.weather.temperature.label;:" style="text-align:right;"/>
              <label value="{day_part/temperature} °C"/>
            </row>
          </xsl:if>
          <xsl:if test="day_part/wind_speed and day_part/wind_direction">
            <row>
              <label value="&yasearch.city.weather.wind.label;:" style="text-align:right;"/>
              <label value="{day_part/wind_direction}, {day_part/wind_speed} м/с"/>
            </row>
          </xsl:if>
          <xsl:if test="day_part/pressure">
            <row>
              <label value="&yasearch.city.weather.pressure.label;:" style="text-align:right;"/>
              <label value="{day_part/pressure} мм.рт.ст."/>
            </row>
          </xsl:if>
          <xsl:if test="day_part/water">
            <row>
              <label value="&yasearch.city.weather.water.label;:" style="text-align:right;"/>
              <label value="{day_part/water} °C"/>
            </row>
          </xsl:if>
          <xsl:if test="day_part/dampness">
            <row>
              <label value="&yasearch.city.weather.dampness.label;:" style="text-align:right;"/>
              <label value="{day_part/dampness} %"/>
            </row>
          </xsl:if>
          
          <xsl:apply-templates select="following-sibling::tonight"/>
          <xsl:apply-templates select="following-sibling::tomorrow"/>
          
        </rows>
      </grid>
    </vbox>
  </hbox>
</xsl:template>

<xsl:template match="tonight">
  <xsl:if test="temperature">
    <row>
      <label value="&yasearch.city.weather.tonight.label;:" style="text-align:right;"/>
      <label value="{temperature} °C"/>
    </row>
  </xsl:if>
</xsl:template>

<xsl:template match="tomorrow">
  <xsl:if test="temperature">
    <row>
      <label value="&yasearch.city.weather.tomorrow.label;:" style="text-align:right;"/>
      <label value="{temperature} °C"/>
    </row>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>