<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "chrome://yasearch/locale/yasearch.dtd">

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>
<xsl:variable name="error" select="counter/data/@error"/>

<xsl:param name="cbl" select="'{'"/>
<xsl:param name="cbr" select="'}'"/>

<xsl:template match="counter">
  <toolbarbutton>
    <xsl:attribute name="yaLabel">
      <xsl:choose>
        <xsl:when test="$error = 0">
          <xsl:value-of select="data/@count"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text>0</xsl:text>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:attribute>
    <menupopup id="yasearch-fotki-menupopup">
      <menuitem label="&yasearch.fotki.reloadCounter.label;"
                oncommand="Ya.nsIYa.manualRefreshHTTPData('fotki')"/>
      <menuseparator/>
      <menuitem oncommand="Ya.loadURI('http://fotki.yandex.ru/users/{@login}/favorites', event, {$cbl}action:3530{$cbr})">
        <xsl:attribute name="label">
          <xsl:text>&yasearch.fotki.favorites.label;</xsl:text>
          <xsl:if test="$error = 0 and data/@count != 0">
            <xsl:value-of select="concat(' (', data/@count, ')')"/>
          </xsl:if>
        </xsl:attribute>
      </menuitem>
      <menuitem oncommand="Ya.loadURI('http://fotki.yandex.ru/users/{@login}', event, {$cbl}action:3510{$cbr})">
        <xsl:attribute name="label">
          <xsl:text>&yasearch.fotki.myfotki.label;</xsl:text>
          <xsl:if test="$error = 0 and data/@views != 0">
            <xsl:value-of select="concat(' (&yasearch.fotki.myfotki.views.label;: ', data/@views, ')')"/>
          </xsl:if>
        </xsl:attribute>
      </menuitem>
      <menuitem oncommand="Ya.loadURI('http://fotki.yandex.ru/users/{@login}/comments', event, {$cbl}action:3540{$cbr})">
        <xsl:attribute name="label">
          <xsl:text>&yasearch.fotki.comments.label;</xsl:text>
          <xsl:if test="$error = 0 and data/@comments != 0">
            <xsl:value-of select="concat(' (', data/@comments, ')')"/>
          </xsl:if>
        </xsl:attribute>
      </menuitem>
      <menuseparator/>
      <menuitem label="&yasearch.fotki.upload.label;"
                oncommand="Ya.loadURI('http://fotki.yandex.ru/upload', event, {$cbl}action:3520{$cbr})"/>
    </menupopup>
  </toolbarbutton>
</xsl:template>

</xsl:stylesheet>