<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "chrome://yasearch/locale/yasearch.dtd">

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>
<xsl:variable name="error" select="counter/data/@error"/>

<xsl:param name="cbl" select="'{'"/>
<xsl:param name="cbr" select="'}'"/>

<xsl:variable name="domain" select="concat('http://', counter/@login, '.ya.ru')"/>

<xsl:template match="counter">
  <toolbarbutton>
    <xsl:attribute name="yaLabel">
      <xsl:choose>
        <xsl:when test="$error = 0">
          <xsl:value-of select="data/@count"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text>0</xsl:text>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:attribute>
    <menupopup id="yasearch-yaru-menupopup">
      <menuitem label="&yasearch.yaru.reloadCounter.label;"
                oncommand="Ya.nsIYa.manualRefreshHTTPData('yaru')"/>
      <menuseparator/>
      <menuitem label="&yasearch.yaru.replies.unread.label;"
                oncommand="Ya.loadURI('{$domain}/replies_history_unread.xml', event, {$cbl}action:3450{$cbr})"/>
       <menuitem label="&yasearch.yaru.friends.read.label;"
                oncommand="Ya.loadURI('{$domain}/friends.xml', event, {$cbl}action:3410{$cbr})"/>
      <menuitem label="&yasearch.yaru.post.text.label;"
                oncommand="Ya.loadURI('{$domain}/posts_add_text.xml', event, {$cbl}action:3420{$cbr})"/>
      <menuitem label="&yasearch.yaru.post.photo.label;"
                oncommand="Ya.loadURI('{$domain}/posts_add_photo.xml', event, {$cbl}action:3430{$cbr})"/>
      <menuitem label="&yasearch.yaru.post.status.label;"
                oncommand="Ya.loadURI('{$domain}/posts_add_status.xml', event, {$cbl}action:3440{$cbr})"/>
      <menuitem label="&yasearch.yaru.post.sendPage.label;"
                oncommand="Ya.pageDataSender.sendToService('yaru', event, {$cbl}action:3460{$cbr})"/>
    </menupopup>
  </toolbarbutton>
</xsl:template>

</xsl:stylesheet>