<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "chrome://yasearch/locale/yasearch.dtd">

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:key name="title" match="yandexmenu/item" use="@title"/>

<xsl:template match="yandexmenu">
  <vbox>
    <xsl:apply-templates select="item[generate-id(.) = generate-id(key('title',@title))]"/>
  </vbox>
</xsl:template>

<xsl:template match="item">
  
  <xsl:variable name="Title" select="@title"/>
  <xsl:variable name="Group" select="parent::yandexmenu/item[@title = $Title]/item"/>
  
  <menu container="true" class="menu-iconic bookmark-item" label="{@title} ({count($Group)})">
    <menupopup>
      <xsl:apply-templates select="$Group"/>
    </menupopup>
  </menu>
    
</xsl:template>

<xsl:template match="item/item">
  <menuitem label="{@title} ({@from})" id="{@url}" oncommand="Ya.clickMail(event);"
            yamailfrom="{@from}" yamailsubject="{@title}" tooltip="yasearch-mail-tooltip"/>
</xsl:template>

</xsl:stylesheet>