<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "chrome://yasearch/locale/yasearch.dtd">

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:param name="cbl" select="'{'"/>
<xsl:param name="cbr" select="'}'"/>

<xsl:template match="button">
  <vbox title="{@text|@chevrontext}" label="{@chevrontext}">
    <toolbarseparator/>
    <toolbarbutton id="yasearch-partner-button"
                   image="{@image}" tooltiptext="{@tooltip}" label="{@text}" yaChevronLabel="{@chevrontext}">
      <xsl:if test="not(@text)">
        <xsl:attribute name="class">
          <xsl:text>yasearch-no-label</xsl:text>
        </xsl:attribute>
      </xsl:if>
      
      <xsl:attribute name="oncommand">
        <xsl:value-of select="concat('if (Ya.checkOnCommandEvent(event)) Ya.loadURI(&#34;', @url, '&#34;, event')"/>
        <xsl:if test="@action">
          <xsl:value-of select="concat(',', $cbl, 'action:', @action, $cbr)"/>
        </xsl:if>
        <xsl:text>);</xsl:text>
      </xsl:attribute>
      
      <xsl:choose>
        <xsl:when test="count(./link) &gt; 0">
          <xsl:attribute name="type">
            <xsl:text>menu-button</xsl:text>
          </xsl:attribute>
          <menupopup>
            <xsl:apply-templates select="link|separator"/>
          </menupopup>
        </xsl:when>
        <xsl:otherwise/> 
      </xsl:choose>
    </toolbarbutton>
  </vbox>
</xsl:template>

<xsl:template match="separator">
  <menuseparator/>
</xsl:template>

<xsl:template match="link">
  <menuitem label="{text()}">
    <xsl:attribute name="oncommand">
      <xsl:value-of select="concat('Ya.loadURI(&#34;', @url, '&#34;, event')"/>
      <xsl:if test="@action">
        <xsl:value-of select="concat(',', $cbl, 'action:', @action, $cbr)"/>
      </xsl:if>
      <xsl:text>);</xsl:text>
    </xsl:attribute>
  </menuitem>
</xsl:template>

</xsl:stylesheet>