<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY % yaBrandDTD SYSTEM "chrome://yasearch/locale/yasearch.dtd">
<!ENTITY % yaWeatherDTD SYSTEM "chrome://yasearch/locale/weather/weather.dtd">
%yaBrandDTD;
%yaWeatherDTD;
]>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:html="http://www.w3.org/1999/xhtml"
  xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
>

<xsl:output method="xml" encoding="UTF-8" indent="no"/>

<xsl:template match="err">
    <tooltip orient="vertical" id="{@yatoolbarid}"
             onpopupshowing="return (document.tooltipNode.tagName == 'toolbarbutton' || document.tooltipNode.tagName == 'menu');">
      <description value="&yasearch.weather.weather.label;: &yasearch._gen.data.nodata.label;"/>
    </tooltip>
</xsl:template>

<xsl:template match="weather">
    <tooltip orient="vertical" id="{@yatoolbarid}" noautohide="true"
             onpopupshowing="return (document.tooltipNode.tagName == 'toolbarbutton' || document.tooltipNode.tagName == 'menu');">
      <vbox>
        <hbox>
          <grid flex="1">
            <columns><column/><column flex="1"/></columns>
            <rows>
              
              <row align="center" style="font-weight:bold">
                <hbox pack="end"><label value="{country}"/></hbox>
                <description value="{city}"/>
              </row>
              
              <xsl:if test="weather_type">
                <row align="center">
                  <hbox pack="end"><label value="&yasearch.weather.weather.label;: "/></hbox>
                  <description value="{weather_type}"/>
                </row>
              </xsl:if>
              
              <xsl:if test="temperature">
                <row align="center">
                  <hbox pack="end"><label value="&yasearch.weather.temperature.label;: "/></hbox>
                  <description value="{temperature} °C"/>
                </row>
              </xsl:if>
              
              <xsl:if test="pressure">
                <row align="center">
                  <hbox pack="end"><label value="&yasearch.weather.pressure.label;: "/></hbox>
                  <description value="{pressure} &yasearch.weather.pressure.mm.label;"/>
                </row>
              </xsl:if>
              
              <xsl:if test="dampness">
                <row align="center">
                  <hbox pack="end"><label value="&yasearch.weather.dampness.label;: "/></hbox>
                  <description value="{dampness} %"/>
                </row>
              </xsl:if>
              
            </rows>
          </grid>
        </hbox>
      </vbox>
    </tooltip>
</xsl:template>

</xsl:stylesheet>